#ifndef CBINAIRE_H
#define CBINAIRE_H

#include <iostream>
#include <sstream>
#include <string>

namespace persistance {

// ________________________________________________________________________________________
class CBinaire {

	public:
		static std::string nomStrategie () { return "CBinaire"; };
		static std::ios_base::openmode mode () { return std::ios::binary; };

		static void lireEntete (std::istream& prFlux) {};
		static std::string lireClasse (std::istream& prFlux);
		static std::string lireMetadonnee (std::istream& prFlux);
		static void lireInfo (std::istream& prFlux, char* const laBuffer, const std::streamsize kpvTaille);
		static std::string lireChaine (std::istream& prFlux);
		static bool dernierLu (std::istream& prFlux);

		static void ecrireEntete (std::ostream& prFlux) {};
		static void ecrireClasse (std::ostream& prFlux, const std::string& kprClasse);
		static void ecrireMetadonnee (std::ostream& prFlux, const std::string& kprMetaDonnee);
		static void ecrireInfo (std::ostream& prFlux, const std::string& kprTypeCPP, const char* const kpaBuffer, const std::streamsize kpvTaille);
		static void ecrireChaine (std::ostream& prFlux, const std::string& kprChaine);
		static void ecrirePied (std::ostream& prFlux) {};
	};

};
#endif // CBINAIRE_H
